
// mtpvcDlg.cpp : t@C
//

#include "stdafx.h"
#include "mtpvc.h"
#include "mtpvcDlg.h"
#include "afxdialogex.h"

#include "CopyResult.h"
#include "CopyProgress.h"

#include "nMtpUtil.h"
#include "nMtpFileDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#if defined _M_IX86
#pragma comment(lib, "nMtpUtil32.lib")
#elif defined _M_X64
#pragma comment(lib, "nMtpUtil64.lib")
#endif

enum {
	iconDevice,
	iconFolder,
};

enum {
	itemFileName,
	itemLastWriteTime,
	itemSize,
	itemAttribute,
};


// CmtpvcDlg _CAO

CmtpvcDlg::CmtpvcDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CmtpvcDlg::IDD, pParent)
    , m_splitter(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CmtpvcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_FILE, m_list_file);
	DDX_Control(pDX, IDC_TREE_FOLDER, m_tree_folder);
}

BEGIN_MESSAGE_MAP(CmtpvcDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_FOLDER, &CmtpvcDlg::OnSelchangedTreeFolder)
	ON_NOTIFY(NM_RCLICK, IDC_TREE_FOLDER, &CmtpvcDlg::OnRclickTreeFolder)
	ON_NOTIFY(NM_RCLICK, IDC_LIST_FILE, &CmtpvcDlg::OnRclickListFile)
	ON_COMMAND(IDM_FILE_COPY, &CmtpvcDlg::OnFileCopy)
	ON_COMMAND(IDM_FOLDER_COPY, &CmtpvcDlg::OnFolderCopy)
	ON_COMMAND(IDM_NEW_COPY, &CmtpvcDlg::OnNewCopy)
	ON_COMMAND(IDM_OVERWRITE_COPY, &CmtpvcDlg::OnOverwriteCopy)
	ON_COMMAND(IDM_SUBFOLDER_COPY, &CmtpvcDlg::OnSubfolderCopy)
	ON_COMMAND(IDM_DELETE, &CmtpvcDlg::OnDelete)
END_MESSAGE_MAP()


// CmtpvcDlg bZ[W nh[

BOOL CmtpvcDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	m_splitter = new CSplitter();
	m_splitter->SetMode(CSplitter::modeVertical);
	m_splitter->CreateSplitter(30, this, &m_tree_folder, &m_list_file, true);

	// ACR\p ImageList 쐬
	m_image_list.Create(16, 16, ILC_COLOR32|ILC_MASK, 6, 6);
	HICON icon;
	icon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEVICE), IMAGE_ICON, 16, 16, 0);
	m_image_list.Add(icon);
	DestroyIcon(icon);
	icon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_FOLDER), IMAGE_ICON, 16, 16, 0);
	m_image_list.Add(icon);
	DestroyIcon(icon);
	m_tree_folder.SetImageList(&m_image_list, TVSIL_NORMAL);

	// t@Cꗗ\̍ڐݒ
	CRect rc;
	m_list_file.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP);
	m_list_file.GetClientRect(rc);
	int wide = (rc.right - rc.left - ::GetSystemMetrics(SM_CXVSCROLL) - ::GetSystemMetrics(SM_CXEDGE) * 2) / 6;
	m_list_file.InsertColumn(itemFileName, _T("t@C"), LVCFMT_LEFT, wide * 2);
	m_list_file.InsertColumn(itemLastWriteTime, _T("XV"), LVCFMT_LEFT, wide * 2);
	m_list_file.InsertColumn(itemSize, _T("TCY"), LVCFMT_LEFT, wide);
	m_list_file.InsertColumn(itemAttribute, _T(""), LVCFMT_LEFT, wide);

	NMtpInitialize();

	// tH_c[ݒ
	SetTree();

	return TRUE;
}

void CmtpvcDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CmtpvcDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CmtpvcDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);
	if(m_splitter) {
		m_splitter->AdjustSize();
	}
}

// tH_c[ڐݒ
void CmtpvcDlg::SetFolder(HTREEITEM ht, CString name)
{
	CNMtpFileFind ff;
	CString path = name + _T("\\*");

	if(ff.FindFile(path)) {
		BOOL flag;
		do {
			flag = ff.FindNextFile();

			if(ff.IsDirectory()) {
				CString *path = new CString(ff.GetFilePath());
				HTREEITEM add_ht = m_tree_folder.InsertItem(ff.GetFileName(), iconFolder, iconFolder, ht);
				m_tree_folder.SetItemData(add_ht, reinterpret_cast<DWORD_PTR>(path));
				SetFolder(add_ht, ff.GetFilePath());
			}
		} while(flag);
		ff.Close();
	}

}

// tH_c[ݒ
void CmtpvcDlg::SetTree()
{
	HANDLE h;

	m_tree_folder.DeleteAllItems();
	// foCXꗗ擾
	h = NMtpFindDeviceFirst();
	if(h != INVALID_HANDLE_VALUE) {
		TCHAR name[MAX_PATH];
		BOOL result = TRUE;
		while(NMtpFindDeviceNext(h, name, MAX_PATH)) {
			HTREEITEM ht = m_tree_folder.InsertItem(name, 0, 0);
			// foCX̃tH_擾
			SetFolder(ht, name);
		}
		NMtpFindDeviceClose(h);
	}
}

// tH_c[ڃf[^
void CmtpvcDlg::ReleaseItemData(HTREEITEM ht)
{
	HTREEITEM htc;
	CString *path;

	while(ht != NULL) {
		if((path = reinterpret_cast<CString *>(m_tree_folder.GetItemData(ht))) != NULL) {
			delete path;
			m_tree_folder.SetItemData(ht, NULL);
		}
		htc = m_tree_folder.GetChildItem(ht);
		if(htc != NULL) {
			ReleaseItemData(htc);
		}
		ht = m_tree_folder.GetNextSiblingItem(ht);
	}
}

BOOL CmtpvcDlg::DestroyWindow()
{
	HTREEITEM ht = m_tree_folder.GetRootItem();
	while(ht != NULL) {
		ReleaseItemData(ht);
		ht = m_tree_folder.GetNextItem(ht, TVGN_NEXT);
	}

	if(m_splitter) {
		delete m_splitter;
	}

	NMtpUninitialize();

	return CDialogEx::DestroyWindow();
}

// 쐬
CString CmtpvcDlg::GetAttributeString(CNMtpFileFind &ff)
{
	CString result;

	if(ff.IsSystem()) {
		result = "System";
	}
	if(ff.IsReadOnly()) {
		if(!result.IsEmpty()) {
			result += ",";
		}
		result = "ReadOnly";
	}
	if(ff.IsHidden()) {
		if(!result.IsEmpty()) {
			result += ",";
		}
		result = "Hidden";
	}
	return result;
}

// t@Cꗗݒ
void CmtpvcDlg::SetFileList(CString path)
{
	CNMtpFileFind ff;
	path += _T("\\*");

	CWaitCursor wc;

	m_list_file.DeleteAllItems();
	int count = 0;
	if(ff.FindFile(path)) {
		BOOL flag;
		do {
			flag = ff.FindNextFile();

			if(!ff.IsDirectory()) {
				m_list_file.InsertItem(count, ff.GetFileName());
				CTime tm;
				ff.GetLastWriteTime(tm);
				m_list_file.SetItemText(count, itemLastWriteTime, tm.Format(_T("%Y/%m/%d %H:%M:%S")));
				CString str;
				str.Format(_T("%d"), (int)ff.GetLength());
				m_list_file.SetItemText(count, itemSize, str);
				m_list_file.SetItemText(count, itemAttribute, GetAttributeString(ff));
				count++;
			}
		} while(flag);
		ff.Close();
	}

}

// tH_c[NbN
void CmtpvcDlg::OnSelchangedTreeFolder(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	if(pNMTreeView->itemNew.hItem != NULL) {
		CString *path = reinterpret_cast<CString *>(m_tree_folder.GetItemData(pNMTreeView->itemNew.hItem));
		if(path) {
			SetFileList(*path);
		}
	}
	*pResult = 0;
}

// tH_c[ENbN
void CmtpvcDlg::OnRclickTreeFolder(NMHDR *pNMHDR, LRESULT *pResult)
{
	CMenu menu;
	CPoint pt;
	UINT flag;
	HTREEITEM ht;

	menu.LoadMenu(IDR_MENU_POPUP);
	GetCursorPos(&pt);
	m_tree_folder.ScreenToClient(&pt);
	if((ht = m_tree_folder.HitTest(pt, &flag)) != NULL) {
		m_tree_folder.SelectItem(ht);
	}
	if(ht != NULL) {
		CMenu* pPopup = menu.GetSubMenu(0);
		GetCursorPos(&pt);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, AfxGetMainWnd());
	}
	*pResult = 0;
}

// t@CꗗENbN
void CmtpvcDlg::OnRclickListFile(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	CMenu menu;
	CPoint pt;

	menu.LoadMenu(IDR_MENU_POPUP);
	GetCursorPos(&pt);
	CMenu* pPopup = menu.GetSubMenu(1);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, AfxGetMainWnd());

	*pResult = 0;
}

// tH_c[ڂpX擾
CString CmtpvcDlg::GetSelectPath()
{
	HTREEITEM ht = m_tree_folder.GetSelectedItem();
	if(ht != NULL) {
		CString *src = reinterpret_cast<CString *>(m_tree_folder.GetItemData(ht));
		if(src != NULL) {
			return *src;
		}
	}
	return _T("");
}

// t@CRs[
void CmtpvcDlg::FileCopy(int flag)
{
	CString src = GetSelectPath();
	if(!src.IsEmpty()) {
		int pos = m_list_file.GetNextItem(-1, LVIS_SELECTED);
		if(pos != -1) {
			CNMtpFileDialog file_dialog(TRUE);
			file_dialog.SetFolderDialog();
			file_dialog.SetTitle(_T("Rs[̃tH_w肵Ă"));

			if(file_dialog.DoModal() == IDOK) {
				CCopyResult result_dialog(this);
				CCopyProgress *progress_dialog = new CCopyProgress();
				progress_dialog->Create(this);

				int count = 0;
				progress_dialog->SetMax(m_list_file.GetSelectedCount());
				progress_dialog->SetPos(count);
				progress_dialog->ShowWindow(SW_SHOW);

				unsigned int result, error;
				CString name, src_name, dst_name;
				while(pos != -1) {
					name = _T("\\") + m_list_file.GetItemText(pos, itemFileName);
					src_name = src + name;
					dst_name = file_dialog.GetPathName() + name;

					progress_dialog->SetMessage(src_name, dst_name);
					progress_dialog->SetPos(count++);
					DoEvents();

					result = NMtpCopyFile(src + name, file_dialog.GetPathName() + name, flag);
					error = GetLastError();

					result_dialog.AddResult(src_name, dst_name, result, error);

					pos = m_list_file.GetNextItem(pos, LVIS_SELECTED);
					if(progress_dialog->CheckStop()) {
						break;
					}
				}
				delete progress_dialog;
				result_dialog.DoModal();
			}
		}
	}
}

void CmtpvcDlg::OnFileCopy()
{
	FileCopy(NMTP_COPY_FAIL_EXISTS);
}

void CmtpvcDlg::OnOverwriteCopy()
{
	FileCopy(0);
}

void CmtpvcDlg::OnNewCopy()
{
	FileCopy(NMTP_COPY_NEWER);
}


void CmtpvcDlg::DoEvents()
{
	MSG msg;

	while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		if(!::IsDialogMessage(m_hWnd, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
}

// tH_Rs[
void CmtpvcDlg::FolderCopy(int flag)
{
	CString src = GetSelectPath();
	if(!src.IsEmpty()) {
		CNMtpFileDialog file_dialog(TRUE);
		file_dialog.SetFolderDialog();
		file_dialog.SetTitle(_T("Rs[̃tH_w肵Ă"));

		if(file_dialog.DoModal() == IDOK) {
			HANDLE handle;
			CCopyResult result_dialog(this);
			CCopyProgress *progress_dialog = new CCopyProgress();
			progress_dialog->Create(this);
			{
				CWaitCursor wc;

				handle = NMtpCopyFolderFirst(src, file_dialog.GetPathName(), flag);
			}
			if(handle != INVALID_HANDLE_VALUE) {
				WCHAR src_name[MAX_PATH], dst_name[MAX_PATH];
				unsigned int result, error, count;

				count = 0;
				progress_dialog->SetMax(NMtpCopyFolderCount(handle));
				progress_dialog->SetPos(count);
				progress_dialog->ShowWindow(SW_SHOW);
				while(NMtpCopyFolderNext(handle, src_name, MAX_PATH, dst_name, MAX_PATH, &result, &error)) {
					progress_dialog->SetMessage(src_name, dst_name);
					progress_dialog->SetPos(count++);

					result_dialog.AddResult(src_name, dst_name, result, error);

					DoEvents();
					if(progress_dialog->CheckStop()) {
						break;
					}
				}
			}
			NMtpCopyFolderClose(handle);

			delete progress_dialog;
			result_dialog.DoModal();
		}
	}
}

void CmtpvcDlg::OnFolderCopy()
{
	FolderCopy(0);
}

void CmtpvcDlg::OnSubfolderCopy()
{
	FolderCopy(NMTP_COPY_SUB_FOLDER);
}


// t@C폜
void CmtpvcDlg::OnDelete()
{
	HTREEITEM ht = m_tree_folder.GetSelectedItem();
	if(ht != NULL) {
		CString *path = reinterpret_cast<CString *>(m_tree_folder.GetItemData(ht));
		if(path != NULL) {
			int pos = m_list_file.GetNextItem(-1, LVIS_SELECTED);
			while(pos != -1) {
				CString name = m_list_file.GetItemText(pos, itemFileName);
				CString delete_name = *path + _T("\\") + name;
				if(NMtpDeleteFile(delete_name)) {
					AfxMessageBox(_T("폜:") + name);
				} else {
					int error = GetLastError();
					CString str;
					str.Format(_T("폜s:%s\nG[R[h:%d"), name, error);
					AfxMessageBox(str);
				}
				pos = m_list_file.GetNextItem(pos, LVIS_SELECTED);
			}
			SetFileList(*path);
		}
	}
}
