#include "stdafx.h"
#include "nMtpFileDialog.h"

using namespace std;

/**
 *	RXgN^
 *	@param bOpenFileDialog TRUE Ńt@CJ_CAO
 *	@param lpszDefExt ftHggq
 *	@param lpszFileName ftHgt@C
 *	@param dwFlags ݒ
 *	@param lpszFilter tB^[ݒ
 *	@param pParentWnd eEChE
 */
CNMtpFileDialog::CNMtpFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName, DWORD dwFlags, LPCTSTR lpszFilter, CWnd *pParentWnd)
{
	m_open_file_flag = bOpenFileDialog;
	if(lpszDefExt) {
		m_initial_ext = lpszDefExt;
	}
	if(lpszFileName) {
		m_initial_file_name = lpszFileName;
	}
	m_flag = dwFlags;
	if(lpszFilter) {
		m_filter = lpszFilter;
	}
	m_parent = pParentWnd;
	if(pParentWnd) {
		m_parent_handle = m_parent->m_hWnd;
	} else {
		m_parent_handle = NULL;
	}
	m_filter_index = 1;
	m_position = 0;
}

/**
 *	fXgN^
 */
CNMtpFileDialog::~CNMtpFileDialog()
{
}

/**
 *	tH_I_CAOݒ
 *	@param flag TRUE ŃtH_I_CAO
 */
void CNMtpFileDialog::SetFolderDialog(BOOL flag)
{
	if(flag) {
		m_flag |= FOS_PICKFOLDERS;
	} else {
		m_flag &= ~FOS_PICKFOLDERS;
	}
}

/**
 *	ftHgtB^Iԍ
 *	@param index Iԍ
 */
void CNMtpFileDialog::SetFilterIndex(int index)
{
	m_filter_index = index;
}

/**
 *	_CAO^Cgݒ
 *	@param title ^Cg
 */
void CNMtpFileDialog::SetTitle(CString title)
{
	m_title = title;
}

/**
 *	_CAOtH_ݒ
 *	@param folder tH_
 */
void CNMtpFileDialog::SetInitialFolder(CString folder)
{
	m_initial_folder = folder;
}

/**
 *	t@Cgq擾
 *	@return gq
 */
CString CNMtpFileDialog::GetFileExt() const
{
	return m_ext;
}

/**
 *	t@C擾
 *	@return 
 */
CString CNMtpFileDialog::GetFileName() const
{
	return m_file_name;
}

/**
 *	t@CtpX擾
 *	@return t@CtpX
 */
CString CNMtpFileDialog::GetPathName() const
{
	return m_path_name;
}

/**
 *	t@C^Cg擾
 *	@return t@C^Cg
 */
CString CNMtpFileDialog::GetFileTitle() const
{
	return m_file_title;
}

/**
 *	̃t@Cݒ
 *	@return TRUE Ŏ̃t@CL
 */
BOOL CNMtpFileDialog::GetNextPathName()
{
	if(m_position < (unsigned int)m_path_list.GetSize()) {
		SetPathName(m_path_list[m_position]);
		m_position++;
		return TRUE;
	}
	return FALSE;
}

/**
 *	t@Cݒ
 *	@param path_name ݒ肷t@C̃tpX
 */
void CNMtpFileDialog::SetPathName(CString path_name)
{
	TCHAR drive[_MAX_DRIVE];
	TCHAR path[MAX_PATH];
	TCHAR fname[_MAX_FNAME];
	TCHAR ext[_MAX_EXT];

	m_path_name = path_name;
	if(!_tsplitpath_s(path_name, drive, ARRAYSIZE(drive), path, ARRAYSIZE(path), fname, ARRAYSIZE(fname), ext, ARRAYSIZE(ext))) {
		m_ext = ext;
		m_ext.TrimLeft(_T("."));
		m_file_name = CString(fname) + CString(ext);
		m_file_title = fname;
	}
}

/**
 *	_CAO\
 *	@return IDOK Ńt@CI
 */
INT_PTR CNMtpFileDialog::DoModal()
{
	int result;
	TCHAR path_name[MAX_PATH];

	if(m_open_file_flag) {
		if(m_flag & FOS_PICKFOLDERS) {
			result = NMtpOpenFolderDialog(m_parent_handle, m_title, m_initial_folder, path_name, MAX_PATH, m_flag);
		} else {
			result = NMtpOpenDialog(m_parent_handle, m_title, m_initial_folder, m_initial_file_name, m_filter, m_filter_index, m_initial_ext, path_name, MAX_PATH, m_flag);
		}
		if(result) {
			SetPathName(path_name);
			if(m_flag & NMTP_DIALOG_ALLOWMULTISELECT) {
				m_path_list.RemoveAll();
				m_path_list.Add(path_name);
				while(NMtpOpenDialogNext(result, path_name, MAX_PATH)) {
					m_path_list.Add(path_name);
				}
				NMtpOpenDialogClose(result);
				m_position = 1;
			}
		}
	} else {
		result = NMtpSaveDialog(m_parent_handle, m_title, m_initial_folder, m_initial_file_name, m_filter, m_filter_index, m_initial_ext, path_name, MAX_PATH, m_flag);
		if(result) {
			SetPathName(path_name);
		}
	}
	if(result) {
		return IDOK;
	}
	return IDCANCEL;
}

IMPLEMENT_DYNAMIC(CNMtpFileDialog, CObject)


