#pragma once

#include "nMtpUtil.h"

class CNMtpFileDialog : public CObject
{
public:
	CNMtpFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt = NULL, LPCTSTR lpszFileName = NULL, DWORD dwFlags = NMTP_DIALOG_DEFAULT, LPCTSTR lpszFilter = NULL, CWnd *pParentWnd = NULL);

	virtual ~CNMtpFileDialog();

public:
	virtual INT_PTR DoModal();
	void Close();

	void SetFolderDialog(BOOL flag = TRUE);
	void SetTitle(CString title);
	void SetInitialFolder(CString dir);
	void SetFilterIndex(int index);
	CString GetFileExt() const;
	CString GetFileName() const;
	CString GetPathName() const;
	CString GetFileTitle() const;
	BOOL GetNextPathName();

protected:
	BOOL m_open_file_flag;
	CString m_initial_ext;
	CString m_initial_file_name;
	CString m_title;
	CString m_initial_folder;
	DWORD m_flag;
	CString m_filter;
	CWnd *m_parent;
	HWND m_parent_handle;
	int m_filter_index;

	CString m_path_name;
	CString m_ext;
	CString m_file_name;
	CString m_file_title;
	CString m_folder;
	unsigned int m_position;
	CStringArray m_path_list;

	void SetPathName(CString path_name);

	DECLARE_DYNAMIC(CNMtpFileDialog)
};
