#pragma once

#include "nMtpUtil.h"

class CNMtpFileFind : public CObject
{
public:
	CNMtpFileFind();

	virtual ~CNMtpFileFind();

public:
	void Close();

	virtual BOOL FindFile(LPCTSTR pstrName = NULL, DWORD dwUnused = 0);
	virtual BOOL FindNextFile();

	virtual BOOL MatchesMask(DWORD dwMask) const;

	virtual BOOL IsDots() const;
	BOOL IsReadOnly() const;
	BOOL IsDirectory() const;
	BOOL IsCompressed() const;
	BOOL IsSystem() const;
	BOOL IsHidden() const;
	BOOL IsTemporary() const;
	BOOL IsNormal() const;
	BOOL IsArchived() const;

	virtual BOOL GetLastWriteTime(FILETIME *pTimeStamp) const;
	virtual BOOL GetLastAccessTime(FILETIME *pTimeStamp) const;
	virtual BOOL GetCreationTime(FILETIME *pTimeStamp) const;
	virtual BOOL GetLastWriteTime(CTime &refTime) const;
	virtual BOOL GetLastAccessTime(CTime &refTime) const;
	virtual BOOL GetCreationTime(CTime &refTime) const;

	ULONGLONG GetLength() const;
	virtual CString GetFileName() const;
	virtual CString GetFilePath() const;
	virtual CString GetFileTitle() const;
	CString GetFileExt() const;
	virtual CString GetRoot() const;
	virtual CString GetFileURL() const;

	static BOOL GetStatus(LPCWSTR lpszFileName, CFileStatus &rStatus);

protected:
	WIN32_FIND_DATA *find_data;
	WIN32_FIND_DATA *next_data;
	HANDLE handle;
	CString root_path;

	DECLARE_DYNAMIC(CNMtpFileFind)
};
